package lab7;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintStream;
import java.util.Scanner;


/*Ghassan Fakher
 * gkf01
 section 4*/
public class HouseList {
	private int numHouses;
	private LinkedList<House> list;
	
	public HouseList()
	{
		list = null;
		numHouses = 0;
	}
	public HouseList(int n)
	{
		list = new LinkedList<House>();
		numHouses = n;
	}
	
	public int getNumHouses()
	{
		return numHouses;
	}
	public void addHouse(House house)
	{
		list.add(house);
		numHouses++;
	}
	public void deleteHouse(House house)
	{
		list.remove(house);
		numHouses--;
	}
	//prints the houses that are in the region
	public void searchByRegion(String region) throws FileNotFoundException
	{
		
		String s = "";
		for(int i = 0; i < list.size(); i++)
		{
			if(list.get(i).address.region.equals(region))
				s += "\n"  + list.get(i).toString() + "\n";
		}
		if(s.equals(""))
			System.out.println("No buildings found");
		else
			System.out.println(s);
	}
	//prints the houses in the price range
	public void searchByPrice(double lowPrice, double highPrice) throws FileNotFoundException
	{
		
		String s = "";
		for(int i = 0; i < list.size(); i++)
		{
			if(list.get(i).price >= lowPrice && list.get(i).price <= highPrice)
				s += "\n" + "****" + list.get(i).toString() + "\n";
		}
		if(s.equals(""))
			System.out.println("No buildings found");
		else
			System.out.println(s);
		
	}
	//prints the houses in that sqaure meter range
	public void searchByArea(int lowArea, int highArea) throws FileNotFoundException
	{
		
		String s = "";
		for(int i = 0; i < list.size(); i++)
		{
			if(list.get(i).area >= lowArea && list.get(i).area <= highArea)
				s += "\n" + "****" + list.get(i).toString() + "\n";
		}
		if(s.equals(""))
			System.out.println("No buildings found");
		else
			System.out.println(s);
	}
	//prints the houses having that many bedrooms
	public void searchByRooms(int rooms) throws FileNotFoundException
	{
		
		String s = "";
		for(int i = 0; i < list.size(); i++)
		{
			if(list.get(i).bedRooms == rooms)
				s += "\n" + "****" + list.get(i).toString() + "\n";
		}
		if(s.equals(""))
			System.out.println("No buildings found");
		else
			System.out.println(s);
	}
	public String toString()
	{
		String s = "[" + list.get(0).toString();
		for(int i = 1; i < list.size(); i++)
		{
			s += ", " + list.get(i).toString();
		}
		s += "]";
		return s;
	}
}
