package lab7;

import java.util.*;


/*Ghassan Fakher
 * gkf01
 section 4*/
public class LinkedList<E> {
	
	private Node<E> front;
	private int size;
	
	
	public LinkedList()
	{
		front = null;
		size = 0;
	}
	public LinkedList(List<E> c)
	{
		this.addAll(c);
	}
	public void add(E data)
	{
		if(front == null)
		{
			front = new Node<E>(data, null);
			size = 1;
		}
		else
		{
			Node<E> temp = front; 
			while(temp.next != null)
			{
				temp = temp.next;
			}
			temp.next = new Node<E>(data, null);
			size++;
		}
		
	}
	public void add(int index, E element)
	{
		if(index != 0)
		{
			Node<E> temp = front; 
			for(int i = 0; i < index - 1; i++)
			{
				temp = temp.next;
			}
			temp.next = new Node<E>(element, temp.next);
		}
		else
		{
			front = new Node<E>(element, front);
		}
		size++;
	}
	//adds an element to the first element of the array
	public void addFirst(E element)
	{
		this.add(0, element);	//calling the add method at the beginning
	}
	//adds the element to the end of the list
	public void addLast(E element)
	{
		Node<E> temp = front; 
		for(int i = 0; i < size - 1; i++)
		{
			temp = temp.next;
		}
		temp.next = new Node<E>(element, temp.next);
		size++;
	}
	//returns the first element in the list
	public E getFirst()
	{
		if(front != null)
			return front.data;
		else
			throw new NoSuchElementException();
	}
	//returns the last element in the list
	public E getLast()
	{
		if(front != null)
		{
			Node<E> temp = front; 
			while(temp.next != null)
			{
				temp = temp.next;
			}
			return temp.data;
		}
		else
		{
			throw new NoSuchElementException();
		}
	}
	//removes an element from the list
	public boolean remove(E element)
	{
		Node<E> temp = front;
		if(this.contains(element) == true)
		{
			if(temp.data.equals(element))
			{
				front = front.next;
			}
			else
			{
				//no need to loop until we reach size because we are certain that element is found
				while(!temp.next.data.equals(element) && temp.next != null)
				{
					temp = temp.next;
				}
				temp.next = temp.next.next;
				
			}
			size--;
			return true;
		}
		else
			return false;
	}
	//removes the first element from the list
	public E removeFirst()
	{
		E removed = front.data;
		front = front.next;
		size--;
		return removed;
	}
	//removes the last element from the list
	public E removeLast()
	{
		Node<E> temp = front;
		for(int i = 0; i < size; i++)
		{
			temp = temp.next;
		}
		E removed = temp.data;
		temp = null;
		size--;
		return removed;
	}
	//returns the number of elements in the list
	public int size()
	{
		return size;
	}
	//returns true if the list contains the given element and false otherwise
	public boolean contains(E element)
	{
		Node<E> temp = front;
		boolean found = false;
		if(this.isEmpty())
			return false;
		else
		{
			for(int i = 0; i < this.size && !found; i++)
			{
				if(temp.data.equals(element))
				{
					found = true;
				}
				else
					temp = temp.next;
			}
			return found;
		}
	}
	//checks whether the list is empty
	public boolean isEmpty()
	{
		return (front == null);
	}
	public boolean addAll(List<E> c)
	{
		if(c == null)
			return false;		//i did not throw an exception although i should have done that. but i should return a boolean 
		else
		{
			Iterator<E> itr  =  c.iterator();
			while(itr.hasNext())
			{
				this.add(itr.next());
			}
		}
		return true;
	}
	//replaces the current element with the given element
	public E set(int index, E element)	//size will not change becuase we will replace an element by a new one
	{
		if(index >=0 && index < size)
		{
			throw new IndexOutOfBoundsException();
		}
		else
		{
			Node<E> temp = front;
			for(int i = 0; i < index - 1; i++)
			{
				temp = temp.next;
			}
			E replaced = temp.next.data;
			temp.next = new Node<E>(element, temp.next.next);
			return replaced;
		}
		
	}
	//returns the element at a specific index
	public E get(int index, E element)
	{
		
		if(index >=0 && index < size)
		{
			if(index == 0)
				return this.getFirst();
			else if(index == size)
				return this.getLast();
			else
			{
				Node<E> temp = front;
				for(int i = 0; i < index; i++)
				{
					temp = temp.next;
				}
				return temp.data;
			}
		}
		else
			throw new IndexOutOfBoundsException();
	}
	public E get(int index)
	{
		Node<E> temp = front;
		for(int i =0; i < index; i++)
		{
			temp = temp.next;
		}
		return temp.data;
	}
	//returns the index of the given element
	public int indexOf(E element)
	{
		int index = -1;
		if(this.contains(element) == false)
			return index;
		else
		{
			Node<E> temp = front;
			boolean found = false;
			for(int i = 0; i < size && !found; i++)
			{
				if(temp.data.equals(element))
				{
					found = true;
					index = i;
				}
				else
					temp = temp.next;
			}
		}
		return index;
	}
	//clears the list from all the elements
	public void clear()
	{
		front = null;
	}
	//string representation of the list
	public String toString()
	{
		if(front == null)
			return "[]";
		else
		{
			Node<E> temp = front;
			String s = "[" + temp.data;
			while(temp.next != null)
			{
				temp = temp.next;
				s += "," + temp.data;
			}
			s += "]";
			return s;
		}
	}
}

